package ch.std.jumpstartreactive.beans;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

public class ReactiveCitiesBean {

	private static List<String> cities;
	
	static {
		cities = new ArrayList<>();
		cities.add("Aarau");
		cities.add("Basel");
		cities.add("Bern");
		cities.add("Biel");
		cities.add("Burgdorf");
		cities.add("Chur");
		cities.add("Davos");
		cities.add("Emmen");
		cities.add("Frauenfeld");
		cities.add("Genf");
		cities.add("Horgen");
		cities.add("Interlaken");
		cities.add("Jaberg");
		cities.add("Lausanne");
		cities.add("Murten");
		cities.add("Neuenburg");
		cities.add("Olten");
		cities.add("Payerne");
		cities.add("Regensdorf");
		cities.add("Solothurn");
		cities.add("St. Gallen");
		cities.add("Thalwil");
		cities.add("Unterseen");
		cities.add("Vallorbe");
		cities.add("Winterthur");
		cities.add("Yverdon");
		cities.add("Zürich");
	}
	
	public static List<String> getSyncCities() {
		return Collections.unmodifiableList(cities);
	}

	public static Flux<String> getCities() {
		return Flux.fromIterable(cities);
	}

	public static Flux<List<String>> getCitiesList() {
		return Flux.just(cities);
	}

	public static Mono<String> find(String find) {
		return Flux.fromIterable(cities).filter((city) -> city.equals(find) ).single();
	}

	public static Mono<String> findCaseInsensitive(String find) {
		return Flux.fromIterable(cities).filter((city) -> city.toLowerCase().equals(find.toLowerCase())).single();
	}

	public static Mono<String> findContains(String find) {
		return Flux.fromIterable(cities).filter((city) -> city.contains(find)).single();
	}

	public Mono<String> findContainscaseInsensitive(String find) {
		return Flux.fromIterable(cities).filter((city) -> city.toLowerCase().contains(find.toLowerCase())).single();
	}

}

