package ch.std.jumpstartreactive;

import java.util.List;

import org.junit.jupiter.api.Test;
import static org.junit.jupiter.api.Assertions.assertTrue;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.http.MediaType;
import org.springframework.test.web.reactive.server.FluxExchangeResult;
import org.springframework.test.web.reactive.server.WebTestClient;

import ch.std.jumpstartreactive.beans.ReactiveCitiesBean;
import reactor.test.StepVerifier;

// see https://springframework.guru/spring-5-webclient/

@SpringBootTest(webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
public class JumpstartreactiveApplicationTests {

	@Autowired
	private WebTestClient webTestClient;

	@Test
	public void contextLoads() {
	}

	@Test
	public void testGetCitiesTextEventStreamCheckFirst() {
		FluxExchangeResult<String> fluxExchangeResult = webTestClient.get().uri("/cities")
				.accept(MediaType.TEXT_EVENT_STREAM).exchange().expectStatus().isOk().expectHeader()
				.contentTypeCompatibleWith(MediaType.TEXT_EVENT_STREAM) //
				.returnResult(String.class);

		StepVerifier.create(fluxExchangeResult.getResponseBody()).expectNext("Aarau").thenCancel().verify();
	}

	@Test
	public void testGetCitiesTextEventStreamCheckAll() {
		FluxExchangeResult<String> fluxExchangeResult = webTestClient.get().uri("/cities")
				.accept(MediaType.TEXT_EVENT_STREAM).exchange().expectStatus().isOk().expectHeader()
				.contentTypeCompatibleWith(MediaType.TEXT_EVENT_STREAM) //
				.returnResult(String.class);

		List<String> cityList = fluxExchangeResult.getResponseBody().collectList().block();
		assertTrue(ReactiveCitiesBean.getSyncCities().size() == cityList.size());
	}

}
